#ifndef LUAENGINE_H
#define LUAENGINE_H

#include "IScriptEngine.h"
#include "PersistantStorage.h"
#include <map>

extern "C"
{
#include "lua/lua.h"
#include "lua/lauxlib.h"
#include "lua/lualib.h"
}


class LUAEngine: public IScriptEngine{
private:
    lua_State *mpLUA;
    PersistantStorage *mpStorage;
public:
	LUAEngine();
	~LUAEngine();

    virtual void notifyEvent(std::string jsonEvent);
    virtual void load(std::string script); 

    PersistantStorage *getStorage();

};

#endif

