#ifndef SERVICEPROVIDER_H
#define SERVICEPROVIDER_H
#include <map>

class EventProcessor;
class Service;
class PGM;
class Insteon;
class WebServer;
class PhoneService;
class SoundService;
class SMTPService;

typedef std::map<std::string,Service*> ServiceMap;

class ServiceProvider{
private:
    ServiceMap mServiceMap;
public:
	ServiceProvider();
	~ServiceProvider();

    void addService(Service *p);
    Service* getService(const std::string& name);

    void startServices(EventProcessor *p);
    void stopServices();

};

#endif

